
import java.util.*;

class Graph{
   LinkedList<Integer>[] ln;
   int verticies;
   Graph(int verticies){
      ln = new LinkedList[verticies];
      for(int i =0;i<verticies;i++){
         ln[i] = new LinkedList();
      }
      this.verticies = verticies;
   }

   void addNode(int vertex1,int vertex2,boolean isDirected){
      // if isDirected is true then added vertex2 to the vertex1; 
      // if not added in both edjges
      ln[vertex1].add(vertex2);
      if(!isDirected){  
         ln[vertex2].add(vertex1);
      } 
   }

   void print(){
      //Printing the graph in readable format.
      for(int i =0 ;i<ln.length;i++){
         LinkedList verticies = ln[i];
         System.out.print(i +"-->");
         for(int j=0;j< verticies.size();j++){
            System.out.print(verticies.get(j));
            System.out.print(" ");
         }
         System.out.println();
      }
   }

   void dfs(int node,int[] visitedArray){
      // Printing the current node and marked it as visited
      System.out.print(node);
      visitedArray[node] = 1;

      // iterating the edge and checking it is visited or not if it is not visited call dfs(notvisitedelement,visitedArray)
      LinkedList<Integer> edges = ln[node];
      for(int i =0;i<edges.size();i++){
         if(visitedArray[edges.get(i)] == 0){
            visitedArray[edges.get(i)] = 1;
            dfs(edges.get(i),visitedArray);
         }
      }
      
   }
   
   void bfs(int node){
      int[] visitedArray = new int[verticies];
      Queue<Integer> queue = new LinkedList<>();
      //Printing the current node and adding it to the queue and marked as visited
      System.out.print(node);
      queue.add(node); 
      visitedArray[node] =1;

      while(!queue.isEmpty()){
         // getting the head of the queue and removing it
         int headNode = queue.poll();

         //Getting edges of that queue
         LinkedList<Integer> edges = ln[headNode];

         // Iteration the edges and adding it to the queue if it is not visited before and printing it
         for(int i = 0;i<edges.size();i++){
            if(visitedArray[edges.get(i)] == 0){
               System.out.print(edges.get(i));
               queue.add(edges.get(i));
               visitedArray[edges.get(i)] = 1;
         }
      }
      }
   }

}



class test{
   public static void main(String[] args){
      Graph gh = new Graph(4);
      gh.addNode(0, 1,true);
      gh.addNode(0, 2,true);
      gh.addNode(1, 2,true);
      gh.addNode(2, 0,true);
      gh.addNode(2, 3,true);
      gh.addNode(3, 3,true);
      gh.print();
      int[] visitedArray = new int[4];
      System.out.print("dfs of the give array is ");
      gh.dfs(2,visitedArray);
      System.out.println();
      System.out.print("bfs of the give array is ");
      gh.bfs(2);
      System.out.println();

   }
}